/********************************** (C) COPYRIGHT *******************************
* File Name          : CH395CMD.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395оƬӿļ
*                      
*******************************************************************************/

/* ͷļ*/
#include "debug.h"
#include "CH395INC.H"
#include "ch395cmd.h"

#define   CH395_OP_INTERFACE_MODE             3
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.H"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.H"
#endif


/********************************************************************************
* Function Name  : CH395CMDReset
* Description    : λCH395оƬ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDReset(void)
{
    xWriteCH395Cmd(CMD00_RESET_ALL);
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395CMDSleep
* Description    : ʹCH395˯״̬
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSleep(void)
{
    xWriteCH395Cmd(CMD00_ENTER_SLEEP);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDSleep
* Description    : ȡоƬԼ̼汾ţ1ֽڣλʾоƬ汾
                   λʾ̼汾
* Input          : None
* Output         : None
* Return         : 1ֽоƬ̼汾
*******************************************************************************/
u8 CH395CMDGetVer(void)
{
    u8 i;
    xWriteCH395Cmd(CMD01_GET_IC_VER);
    i = xReadCH395Data();
    xEndCH395Cmd();
    return i;
}

/********************************************************************************
* Function Name  : CH395CMDCheckExist
* Description    : ڲӲԼӿͨѶ
* Input          : testdata 1ֽڲ
* Output         : None
* Return         : ӲOK testdataλȡ
*******************************************************************************/
u8 CH395CMDCheckExist(u8 testdata)
{
    u8 i;

    xWriteCH395Cmd(CMD11_CHECK_EXIST);
    xWriteCH395Data(testdata);
    i = xReadCH395Data();
    xEndCH395Cmd();
    return i;
}

/********************************************************************************
* Function Name  : CH395CMDSetPHY
* Description    : PHYҪCH395 PHYΪ100/10M ȫ˫˫CH395Ĭ
                    ΪԶЭ̡
* Input          : phystat οPHY /״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetPHY(u8 phystat)
{
    xWriteCH395Cmd(CMD10_SET_PHY);
    xWriteCH395Data(phystat);
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395CMDGetPHYStatus
* Description    : ȡPHY״̬
* Input          : None
* Output         : None
* Return         : ǰCH395PHY״̬οPHY/״̬
*******************************************************************************/
u8 CH395CMDGetPHYStatus(void)
{
    u8 i;

    xWriteCH395Cmd(CMD01_GET_PHY_STATUS);
    i = xReadCH395Data();
    xEndCH395Cmd();
    return i;
}

/*******************************************************************************
* Function Name  : CH395CMDGetGlobIntStatus
* Description    : ȡȫж״̬յCH395Զȡжϣ0x43°汾ʹ
* Input          : None
* Output         : None
* Return         : صǰȫж״̬
*******************************************************************************/
u8 CH395CMDGetGlobIntStatus(void)
{
    u8 init_status;

    xWriteCH395Cmd(CMD01_GET_GLOB_INT_STATUS);
    init_status = xReadCH395Data();
    xEndCH395Cmd();
    return  init_status;
}

/********************************************************************************
* Function Name  : CH395CMDInitCH395
* Description    : ʼCH395оƬ
* Input          : None
* Output         : None
* Return         : ִн
*******************************************************************************/
u8 CH395CMDInitCH395(void)
{
    u8 i = 0;
    u8 s = 0;

    xWriteCH395Cmd(CMD0W_INIT_CH395);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(10);                                                /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
//        printf("GetCmdStatus %02x\r\n",s);
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳,Ҫ500MSִ */
    }
    return s;
}

/********************************************************************************
* Function Name  : CH395CMDSetUartBaudRate
* Description    : CH395ڲʣڴģʽЧ
* Input          : baudrate ڲ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetUartBaudRate(UINT32 baudrate)
{
    xWriteCH395Cmd(CMD31_SET_BAUDRATE);
    xWriteCH395Data((u8)baudrate);
    xWriteCH395Data((u8)((UINT16)baudrate >> 8));
    xWriteCH395Data((u8)(baudrate >> 16));
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395GetCmdStatus
* Description    : ȡִ״̬ĳЩҪȴִн
* Input          : None
* Output         : None
* Return         : һִ״̬
*******************************************************************************/
u8 CH395GetCmdStatus(void)
{
    u8 i;

    xWriteCH395Cmd(CMD01_GET_CMD_STATUS);
    i = xReadCH395Data();
    xEndCH395Cmd();
    return i;
}

/********************************************************************************
* Function Name  : CH395CMDSetIPAddr
* Description    : CH395IPַ
* Input          : ipaddr ָIPַ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetIPAddr(u8 *ipaddr)
{
    u8 i;

    xWriteCH395Cmd(CMD40_SET_IP_ADDR);
    for(i = 0; i < 4;i++)xWriteCH395Data(*ipaddr++);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDSetGWIPAddr
* Description    : CH395IPַ
* Input          : ipaddr ָIPַ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetGWIPAddr(u8 *gwipaddr)
{
    u8 i;

    xWriteCH395Cmd(CMD40_SET_GWIP_ADDR);
    for(i = 0; i < 4;i++)xWriteCH395Data(*gwipaddr++);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDSetMASKAddr
* Description    : CH395룬ĬΪ255.255.255.0
* Input          : maskaddr ַָ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetMASKAddr(u8 *maskaddr)
{
    u8 i;

    xWriteCH395Cmd(CMD40_SET_MASK_ADDR);
    for(i = 0; i < 4;i++)xWriteCH395Data(*maskaddr++);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDSetMACAddr
* Description    : CH395MACַ
* Input          : amcaddr MACַָ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetMACAddr(u8 *amcaddr)
{
    u8 i;

    xWriteCH395Cmd(CMD60_SET_MAC_ADDR);
    for(i = 0; i < 6;i++)xWriteCH395Data(*amcaddr++);
    xEndCH395Cmd();
    Delay_Ms(100);
}

/********************************************************************************
* Function Name  : CH395CMDGetMACAddr
* Description    : ȡCH395MACַ
* Input          : amcaddr MACַָ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDGetMACAddr(u8 *amcaddr)
{
    u8 i;

    xWriteCH395Cmd(CMD06_GET_MAC_ADDR);
    for(i = 0; i < 6;i++)*amcaddr++ = xReadCH395Data();
    xEndCH395Cmd();
 }

/*******************************************************************************
* Function Name  : CH395CMDSetMACFilt
* Description    : MACˡ
* Input          : filtype ο MAC
                   table0 Hash0
                   table1 Hash1
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetMACFilt(u8 filtype,UINT32 table0,UINT32 table1)
{
    xWriteCH395Cmd(CMD90_SET_MAC_FILT);
    xWriteCH395Data(filtype);
    xWriteCH395Data((u8)table0);
    xWriteCH395Data((u8)((UINT16)table0 >> 8));
    xWriteCH395Data((u8)(table0 >> 16));
    xWriteCH395Data((u8)(table0 >> 24));

    xWriteCH395Data((u8)table1);
    xWriteCH395Data((u8)((UINT16)table1 >> 8));
    xWriteCH395Data((u8)(table1 >> 16));
    xWriteCH395Data((u8)(table1 >> 24));
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDGetUnreachIPPT
* Description    : ȡɴϢ (IP,Port,Protocol Type)
* Input          : list ȡĲɴ
                        1ֽΪɴ룬ο ɴ(CH395INC.H)
                        2ֽΪIPЭ
                        3-4ֽΪ˿ں
                        4-8ֽΪIPַ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDGetUnreachIPPT(u8 *list)
{
    u8 i;

    xWriteCH395Cmd(CMD08_GET_UNREACH_IPPORT);
    for(i = 0; i < 8; i++)
    {
        *list++ = xReadCH395Data();
    }   
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDGetRemoteIPP
* Description    : ȡԶ˵IPͶ˿ڵַһTCP Serverģʽʹ
* Input          : sockindex Socket
                   list IPͶ˿
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDGetRemoteIPP(u8 sockindex,u8 *list)
{
    u8 i;

    xWriteCH395Cmd(CMD06_GET_REMOT_IPP_SN);
    xWriteCH395Data(sockindex);
    for(i = 0; i < 6; i++)
    {
        *list++ = xReadCH395Data();
    }   
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395SetSocketDesIP
* Description    : socket nĿIPַ
* Input          : sockindex Socket
                   ipaddr ָIPַ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketDesIP(u8 sockindex,u8 *ipaddr)
{
    xWriteCH395Cmd(CMD50_SET_IP_ADDR_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(*ipaddr++);
    xWriteCH395Data(*ipaddr++);
    xWriteCH395Data(*ipaddr++);
    xWriteCH395Data(*ipaddr++);
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395SetSocketProtType
* Description    : socket Э
* Input          : sockindex Socket
                   prottype Эͣο socketЭͶ(CH395INC.H)
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketProtType(u8 sockindex,u8 prottype)
{
    xWriteCH395Cmd(CMD20_SET_PROTO_TYPE_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(prottype);
    xEndCH395Cmd();
}

/*******************************************************************************

* Function Name  : CH395SetSocketDesPort
* Description    : socket nЭ
* Input          : sockindex Socket
                   desprot 2ֽĿĶ˿
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketDesPort(u8 sockindex,UINT16 desprot)
{
    xWriteCH395Cmd(CMD30_SET_DES_PORT_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data((u8)desprot);
    xWriteCH395Data((u8)(desprot >> 8));
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395SetSocketSourPort
* Description    : socket nЭ
* Input          : sockindex Socket
                   desprot 2ֽԴ˿
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketSourPort(u8 sockindex,UINT16 surprot)
{
    xWriteCH395Cmd(CMD30_SET_SOUR_PORT_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data((u8)surprot);
    xWriteCH395Data((u8)(surprot>>8));
    xEndCH395Cmd();
}

/******************************************************************************
* Function Name  : CH395SetSocketIPRAWProto
* Description    : IPģʽ£socket IPЭֶ
* Input          : sockindex Socket
                   prototype IPRAWģʽ1ֽЭֶ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketIPRAWProto(u8 sockindex,u8 prototype)
{
    xWriteCH395Cmd(CMD20_SET_IPRAW_PRO_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(prototype);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395EnablePing
* Description    : /ر PING
* Input          : enable : 1  PING
                          0  رPING
* Output         : None
* Return         : None
*******************************************************************************/
void CH395EnablePing(u8 enable)
{
    xWriteCH395Cmd(CMD01_PING_ENABLE);
    xWriteCH395Data(enable);
    xEndCH395Cmd();
}


/********************************************************************************
* Function Name  : CH395SendData
* Description    : ͻд
* Input          : sockindex Socket
                   databuf  ݻ
                   len   
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SendData(u8 sockindex,u8 *databuf,UINT16 len)
{
    UINT16 i;

    xWriteCH395Cmd(CMD30_WRITE_SEND_BUF_SN);
    xWriteCH395Data((u8)sockindex);
    xWriteCH395Data((u8)len);
    xWriteCH395Data((u8)(len>>8));
   
    for(i = 0; i < len; i++)
    {
        xWriteCH395Data(*databuf++);
    }
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395GetRecvLength
* Description    : ȡջ
* Input          : sockindex Socket
* Output         : None
* Return         : ؽջЧ
*******************************************************************************/
UINT16 CH395GetRecvLength(u8 sockindex)
{
    UINT16 i;

    xWriteCH395Cmd(CMD12_GET_RECV_LEN_SN);
    xWriteCH395Data((u8)sockindex);
    i = xReadCH395Data();
    i = (UINT16)(xReadCH395Data()<<8) + i;
    xEndCH395Cmd();
    return i;
}

/*******************************************************************************
* Function Name  : CH395ClearRecvBuf
* Description    : ջ
* Input          : sockindex Socket
* Output         : None
* Return         : None
*******************************************************************************/
void CH395ClearRecvBuf(u8 sockindex)
{
    xWriteCH395Cmd(CMD10_CLEAR_RECV_BUF_SN);
    xWriteCH395Data((u8)sockindex);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395GetRecvLength
* Description    : ȡջ
* Input          : sockindex Socket
                   len   
                   pbuf  
* Output         : None
* Return         : None
*******************************************************************************/
void CH395GetRecvData(u8 sockindex,UINT16 len,u8 *pbuf)
{
    UINT16 i;
    if(!len)return;
    xWriteCH395Cmd(CMD30_READ_RECV_BUF_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data((u8)len);
    xWriteCH395Data((u8)(len>>8));
    Delay_Ms(1);
    for(i = 0; i < len; i++)
    {
       *pbuf = xReadCH395Data();
       pbuf++;
    }   
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDSetRetryCount
* Description    : Դ
* Input          : count ֵΪ20
* Output         : None
* Return         : None
********************************************************************************/
void CH395CMDSetRetryCount(u8 count)
{
    xWriteCH395Cmd(CMD10_SET_RETRAN_COUNT);
    xWriteCH395Data(count);
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDSetRetryPeriod
* Description    : 
* Input          : period ڵλΪ룬1000ms
* Output         : None
* Return         : None
*******************************************************************************/
void CH395CMDSetRetryPeriod(UINT16 period)
{
    xWriteCH395Cmd(CMD10_SET_RETRAN_COUNT);
    xWriteCH395Data((u8)period);
    xWriteCH395Data((u8)(period>>8));
    xEndCH395Cmd();
}

/********************************************************************************
* Function Name  : CH395CMDGetSocketStatus
* Description    : ȡsocket
* Input          : None
* Output         : socket n״̬Ϣ1ֽΪsocket 򿪻߹ر
                   2ֽΪTCP״̬
* Return         : None
*******************************************************************************/
void CH395CMDGetSocketStatus(u8 sockindex,u8 *status)
{
    xWriteCH395Cmd(CMD12_GET_SOCKET_STATUS_SN);
    xWriteCH395Data(sockindex);
    *status++ = xReadCH395Data();
    *status++ = xReadCH395Data();
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395OpenSocket
* Description    : socketҪȴִгɹ
* Input          : sockindex Socket
* Output         : None
* Return         : ִн
*******************************************************************************/
u8  CH395OpenSocket(u8 sockindex)
{
    u8 i = 0;
    u8 s = 0;
    xWriteCH395Cmd(CMD1W_OPEN_SOCKET_SN);
    xWriteCH395Data(sockindex);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(5);                                                 /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/*******************************************************************************
* Function Name  : CH395CloseSocket
* Description    : رsocket
* Input          : sockindex Socket
* Output         : None
* Return         : ִн
*******************************************************************************/
u8  CH395CloseSocket(u8 sockindex)
{
    u8 i = 0;
    u8 s = 0;
    xWriteCH395Cmd(CMD1W_CLOSE_SOCKET_SN);
    xWriteCH395Data(sockindex);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(5);                                                 /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/********************************************************************************
* Function Name  : CH395TCPConnect
* Description    : TCPӣTCPģʽЧҪȴִгɹ
* Input          : sockindex Socket
* Output         : None
* Return         : ִн
*******************************************************************************/
u8 CH395TCPConnect(u8 sockindex)
{
    u8 i = 0;
    u8 s = 0;
    xWriteCH395Cmd(CMD1W_TCP_CONNECT_SN);
    xWriteCH395Data(sockindex);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(5);                                                 /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/******************************************************************************
* Function Name  : CH395TCPListen
* Description    : TCPTCPģʽЧҪȴִгɹ
* Input          : sockindex Socket
* Output         : None
* Return         : ִн
*******************************************************************************/
u8 CH395TCPListen(u8 sockindex)
{
    u8 i = 0;
    u8 s = 0;
    xWriteCH395Cmd(CMD1W_TCP_LISTEN_SN);
    xWriteCH395Data(sockindex);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(5);                                                 /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/********************************************************************************
* Function Name  : CH395TCPDisconnect
* Description    : TCPϿTCPģʽЧҪȴִгɹ
* Input          : sockindex Socket
* Output         : None
* Return         : None
*******************************************************************************/
u8 CH395TCPDisconnect(u8 sockindex)
{
    u8 i = 0;
    u8 s = 0;
    xWriteCH395Cmd(CMD1W_TCP_DISNCONNECT_SN);
    xWriteCH395Data(sockindex);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(5);                                                 /* ʱѯ2MS*/
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/*******************************************************************************
* Function Name  : CH395GetSocketInt
* Description    : ȡsocket nж״̬
* Input          : sockindex   socket
* Output         : None
* Return         : ж״̬
*******************************************************************************/
u8 CH395GetSocketInt(u8 sockindex)
{
    u8 intstatus;
    xWriteCH395Cmd(CMD11_GET_INT_STATUS_SN);
    xWriteCH395Data(sockindex);
    Delay_Us(2);
    intstatus = xReadCH395Data();
    xEndCH395Cmd();
    return intstatus;
}

/*******************************************************************************
* Function Name  : CH395CRCRet6Bit
* Description    : ԶಥַCRC㣬ȡ6λ
* Input          : mac_addr   MACַ
* Output         : None
* Return         : CRC32ĸ6λ
*******************************************************************************/
u8 CH395CRCRet6Bit(u8 *mac_addr)
{
    INT32 perByte;
    INT32 perBit;
    const UINT32 poly = 0x04C11DB7;
    UINT32 crc_value = 0xFFFFFFFF;
    u8 c;
    for ( perByte = 0; perByte < 6; perByte ++ ) 
    {
        c = *(mac_addr++);
        for ( perBit = 0; perBit < 8; perBit++ ) 
        {
            crc_value = (crc_value<<1)^((((crc_value>>31)^c)&0x01)?poly:0);
            c >>= 1;
        }
    }
    crc_value=crc_value>>26;                                      
    return ((u8)crc_value);
}

/******************************************************************************
* Function Name  : CH395DHCPEnable
* Description    : /ֹͣDHCP
* Input          : flag   1:DHCP;0ֹͣDHCP
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
u8  CH395DHCPEnable(u8 flag)
{
    u8 i = 0;
    u8 s;
    xWriteCH395Cmd(CMD10_DHCP_ENABLE);
    xWriteCH395Data(flag);
    xEndCH395Cmd();
    while(1)
    {
        Delay_Ms(20);
        s = CH395GetCmdStatus();                                     /* ܹƵѯ*/
        if(s !=CH395_ERR_BUSY)break;                                 /* CH395оƬæ״̬*/
        if(i++ > 200)return CH395_ERR_UNKNOW;                        /* ʱ˳*/
    }
    return s;
}

/******************************************************************************
* Function Name  : CH395GetDHCPStatus
* Description    : ȡDHCP״̬
* Input          : None
* Output         : None
* Return         : DHCP״̬0Ϊɹֵʾ
*******************************************************************************/
u8 CH395GetDHCPStatus(void)
{
    u8 status;
    xWriteCH395Cmd(CMD01_GET_DHCP_STATUS);
    status = xReadCH395Data();
    xEndCH395Cmd();
    return status;
}

/*******************************************************************************
* Function Name  : CH395GetIPInf
* Description    : ȡIPصַ
* Input          : None
* Output         : 12ֽڵIP,صַ
* Return         : None
*******************************************************************************/
void CH395GetIPInf(u8 *addr)
{
    u8 i;
    xWriteCH395Cmd(CMD014_GET_IP_INF);
    for(i = 0; i < 20; i++)
    {
     *addr++ = xReadCH395Data();
    }
    xEndCH395Cmd();
}

/*******************************************************************************
* Function Name  : CH395WriteGPIOAddr
* Description    : дGPIOĴ
* Input          : regadd   Ĵַ
*                regval   Ĵֵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395WriteGPIOAddr(u8 regadd,u8 regval)
{
    xWriteCH395Cmd(CMD20_WRITE_GPIO_REG);
    xWriteCH395Data(regadd);
    xWriteCH395Data(regval);
}

/*******************************************************************************
* Function Name  : CH395ReadGPIOAddr
* Description    : GPIOĴ
* Input          : regadd   Ĵַ
* Output         : None
* Return         : Ĵֵ
*******************************************************************************/
u8 CH395ReadGPIOAddr(u8 regadd)
{
    u8 i;
    xWriteCH395Cmd(CMD10_READ_GPIO_REG);
    xWriteCH395Data(regadd);
    Delay_Ms(1);
    i = xReadCH395Data();
    return i;
}

/*******************************************************************************
* Function Name  : CH395EEPROMErase
* Description    : EEPROM
* Input          : None
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
u8 CH395EEPROMErase(void)
{
    u8 i;
    xWriteCH395Cmd(CMD00_EEPROM_ERASE);
    while(1)
    {
        Delay_Ms(20);
       i = CH395GetCmdStatus();
       if(i == CH395_ERR_BUSY)continue;
       break;
    }
    return i;
}

/*******************************************************************************
* Function Name  : CH395EEPROMWrite
* Description    : дEEPROM
* Input          : eepaddr  EEPROMַ
*                buf      ַ
*                len      
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
u8 CH395EEPROMWrite(UINT16 eepaddr,u8 *buf,u8 len)
{
    u8 i;
    xWriteCH395Cmd(CMD30_EEPROM_WRITE);
    xWriteCH395Data((u8)(eepaddr));
    xWriteCH395Data((u8)(eepaddr >> 8));
    xWriteCH395Data(len);  
    while(len--)xWriteCH395Data(*buf++);
    while(1)
    {
        Delay_Ms(20);
       i = CH395GetCmdStatus();
       if(i == CH395_ERR_BUSY)continue;
       break;
    }
    return i;
}
  
/*******************************************************************************
* Function Name  : CH395EEPROMRead
* Description    : дEEPROM
* Input          : eepaddr  EEPROMַ
*                buf      ַ
*                len      
* Output         : None
* Return         : None
*******************************************************************************/
void CH395EEPROMRead(UINT16 eepaddr,u8 *buf,u8 len)
{
    xWriteCH395Cmd(CMD30_EEPROM_READ);
    xWriteCH395Data((u8)(eepaddr));
    xWriteCH395Data((u8)(eepaddr >> 8));
    xWriteCH395Data(len);  
    Delay_Ms(1);
    while(len--)*buf++ = xReadCH395Data();
}

/*******************************************************************************
* Function Name  : CH395SetTCPMss
* Description    : TCP MSSֵ
* Input          : tcpmss 
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetTCPMss(UINT16 tcpmss)
{
    xWriteCH395Cmd(CMD20_SET_TCP_MSS);
    xWriteCH395Data((u8)(tcpmss));
    xWriteCH395Data((u8)(tcpmss >> 8));
}

/*******************************************************************************
* Function Name  : CH395SetSocketRecvBuf
* Description    : Socketջ
* Input          : sockindex  socket
                 startblk   ʼַ
                 blknum     λ λΪ512ֽ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketRecvBuf(u8 sockindex,u8 startblk,u8 blknum)
{
    xWriteCH395Cmd(CMD30_SET_RECV_BUF);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(startblk);
    xWriteCH395Data(blknum);
}

/*******************************************************************************
* Function Name  : CH395SetSocketSendBuf
* Description    : Socketͻ
* Input          : sockindex  socket
                 startblk   ʼַ
                 blknum     λ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetSocketSendBuf(u8 sockindex,u8 startblk,u8 blknum)
{
    xWriteCH395Cmd(CMD30_SET_SEND_BUF);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(startblk);
    xWriteCH395Data(blknum);
}

/*******************************************************************************
* Function Name  : CH395UDPSendTo
* Description    : UDPָIPͶ˿ڷ
* Input          : buf     : ݻ
                   len     : ݳ
				   ip      : ĿIP
				   port    : Ŀ˿
				   sockeid : socketֵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395UDPSendTo(u8 *buf,UINT32 len,u8 *ip,UINT16 port,u8 sockindex)
{
    CH395SetSocketDesIP(sockindex,ip);                            /* socket 0ĿIPַ */         
    CH395SetSocketDesPort(sockindex,port);
    CH395SendData(sockindex,buf,len);    
}

/*******************************************************************************
* Function Name  : CH395SetStartPara
* Description    : CH395
* Input          : mdata
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetStartPara(UINT32 mdata)
{
    xWriteCH395Cmd(CMD40_SET_FUN_PARA);
    xWriteCH395Data((u8)mdata);
    xWriteCH395Data((u8)((UINT16)mdata>>8));
    xWriteCH395Data((u8)(mdata >> 16));
    xWriteCH395Data((u8)(mdata >> 24));
}

/*******************************************************************************
* Function Name  : CH395CMDGetGlobIntStatus
* Description    : ȡȫж״̬յCH395Զȡж,0x44ϰ汾ʹ
* Input          : None
* Output         : None
* Return         : صǰȫж״̬
*******************************************************************************/
UINT16 CH395CMDGetGlobIntStatus_ALL(void)
{
		UINT16 init_status;
		xWriteCH395Cmd(CMD02_GET_GLOB_INT_STATUS_ALL);
		Delay_Us(2);
		init_status = xReadCH395Data();
		init_status = (UINT16)(xReadCH395Data()<<8) + init_status;
		xEndCH395Cmd();
		return 	init_status;
}

/*******************************************************************************
* Function Name  : CH395SetKeepLive
* Description    : keepalive
* Input          : sockindex Socket
*                  cmd 0ر 1
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetKeepLive(u8 sockindex,u8 cmd)
{
    xWriteCH395Cmd(CMD20_SET_KEEP_LIVE_SN);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(cmd);
}

/*******************************************************************************
* Function Name  : CH395KeepLiveCNT
* Description    : keepaliveԴ
* Input          : cnt Դ
* Output         : None
* Return         : None
*******************************************************************************/
void CH395KeepLiveCNT(u8 cnt)
{
    xWriteCH395Cmd(CMD10_SET_KEEP_LIVE_CNT);
    xWriteCH395Data(cnt);
}

/*******************************************************************************
* Function Name  : CH395KeepLiveIDLE
* Description    : KEEPLIVE
* Input          : idle ʱ䣨λms
* Output         : None
* Return         : None
*******************************************************************************/
void CH395KeepLiveIDLE(UINT32 idle)
{
    xWriteCH395Cmd(CMD40_SET_KEEP_LIVE_IDLE);
    xWriteCH395Data((u8)idle);
    xWriteCH395Data((u8)((UINT16)idle>>8));
    xWriteCH395Data((u8)(idle >> 16));
    xWriteCH395Data((u8)(idle >> 24));
}

/*******************************************************************************
* Function Name  : CH395KeepLiveINTVL
* Description    : KeepLiveʱ 
* Input          : intvl ʱ䣨λms
* Output         : None
* Return         : None
*******************************************************************************/
void CH395KeepLiveINTVL(UINT32 intvl)
{
    xWriteCH395Cmd(CMD40_SET_KEEP_LIVE_INTVL);
    xWriteCH395Data((u8)intvl);
    xWriteCH395Data((u8)((UINT16)intvl>>8));
    xWriteCH395Data((u8)(intvl >> 16));
    xWriteCH395Data((u8)(intvl >> 24));
}

/*******************************************************************************
* Function Name  : CH395SetTTLNum
* Description    : TTL
* Input          : sockindex Socket
*                  TTLnum:TTL
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SetTTLNum(u8 sockindex,u8 TTLnum)
{
    xWriteCH395Cmd(CMD20_SET_TTL);
    xWriteCH395Data(sockindex);
    xWriteCH395Data(TTLnum);
}

/**************************** endfile *************************************/



